#include <iostream>

#include <QCoreApplication>
#include <VDream/Common/VCommon.h>
#include <VDream/Log/VLog.h>

using namespace std;

class Param
{
public:
  QString   msg;
  bool      flush;
  bool      linefeed;

public:
  Param()
  {
    msg      = "";
    flush    = false;
    linefeed = false;
  }

  bool parse(int argc, char* argv[])
  {
    if (argc < 2) return false;
    msg = argv[1];

    int i = 2;
    while (i < argc)
    {
      QString s = argv[i];
      if (s == "-f")
      {
        flush = true;
      } else
      if (s == "-l")
      {
        linefeed = true;
      } else
      {
        cout << "invalid option " << qPrintable(s) << endl;
        return false;
      }
      i++;
    }
    return true;
  }

  static void usage()
  {
    cout << "mid <msg> [-f][-l]\n";
    cout << "-f            : flush (default false)\n";
    cout << "-l            : linefeed(default false)\n";
  }
};

int main(int argc, char *argv[])
{
  QCoreApplication a(argc, argv);

  Param param;
  if (!param.parse(argc, argv))
  {
    Param::usage();
    return 0;
  }

  while (true)
  {
    string _s;
    cin >> _s;
    if (cin.bad())
    {
      LOG_DEBUG("cin.bad");
      break;
    }
    QString s = _s.c_str();
    s += param.msg;
    if (param.linefeed) s += "\n";
    cout << qPrintable(s);
    LOG_TRACE("mid %s", qPrintable(s));
    if (cin.eof())
    {
      LOG_DEBUG("cin.eof");
      break;
    }
  }

  return 0;
}
